"""Pagination utility functions."""

from collections.abc import Sequence
from urllib.parse import parse_qs, urlparse

from slices_bi_client.models.page_link import PageLink as BIPageLink
from slices_expauth_client.models.page_link import PageLink


def get_next_page_marker(page_links: Sequence[PageLink | BIPageLink]) -> str | None:
    """Get the next page marker from a list of page links."""

    for link in page_links:
        if link.rel == "next":
            return parse_qs(urlparse(link.href).query).get("marker", [None])[0]
    return None
